//CellNX̐錾
class Cell{

public:
	float latitude;				// ܓx [b] latitude [second]
	float longitude;			// ox [b] longitude [second]

	float topoScale;				// ԕ\bPʂŗ^ spatial resolution given as second unit

	int down;					/* (NN1,NE2,EE3,SE4,SS5,SW6,WW7,NW8,͌0,En9,lȂ10,C-1) */
	int basin;					/* Wʐ */
	int thre_basin;				/* EWʐ */

	int numberOfUpStreamGrid;	/* 㗬Obh̐ */
	int riverNumber;			/* ͌ꂼԍŁÃObhǂ̉͌ɂȂĂ邩 */

	float longitudinalLength;	/* ox̂PObh̒[m] */
	float latitudeLength;		/* ܓx̂PObh̒[m] */
	float med;					/* Wl[m] */

	class ROF* ROFCell;			/* ̃Obh܂܂~ʃZ */
	class Cell* downStreamGrid;	/* Obh */
	class Cell* upStreamGrid[7];/* 㗬Obh */

	// added on May 20, 2013
	int gridKind;	// kind of grid. 
					// -1: Edge of study region
					//  1: Inside of study region
					// 99: Dam
					//100: Pondage reservoir


	bool isThisGridEnd;			/* [ObhA܂͊CObh */

	float*** mQn_memory;		/* ЂƌmQnLz */

	int row, col;				// iqԍ for debug

//member and member function for kinematic wave method

	// p^
	double mMan_channel;	// Manning roughness coefficient for channel }jȎexW (m-s)
	double mMan_slope;	// Manning roughness coefficient for slope }jȎexW (m-s)
	double mKa;     // Hydraulic conductivity W (m-s)
	//double mD;      // Total Soil Layer yw (mn)
	double mDa;     // Aperturean Soil Layer 󌄕̓yw (mn)
	double mDm;     // Matrix Soil Layer }gNX̓yw (mn)
	double mBeta;   // Unsaturated Index sOaxw (-)
	double mVa;     // Velocity of Matrix Soil Layer 󌄕̓`dx (m-s)
	double mQm;		// Maximum discharge of capillary layer }gNXw̒Pʕ (m2)
	double mK;		// R = mK * pow(A, mZ) (mn)
	double mZ;		// R = mK * pow(A, mZ) (mn)
	double mMan;	// }jȎexW (m-s)
	double mL;		// ͓ (m)
	double mB;      // ͓ (m)
	double mG;		// ͓z (tangent ̒l)
	int mDiv;		// ԕ (-)
	double mDx;		// ԍԊu (m)
	int mDt;		// ԍԊu (sec)
	double mTheta;	// d݌W (-)
	
	int mthre_basin; // EWʐ

 	double mAlpha_slope;  // Ζʂkinematic 萔 
					 // mAlpha = 1 / mMan * pow(mK, 2/3) * sqrt(mG)
 	double mAlpha_channel;  // ͓kinematic 萔 
					 // mAlpha = 1 / mMan * pow(mK, 2/3) * sqrt(mG)

 	double mM;		// kinematic 萔
					// mM = 1 + 2/3*mZ

	//Added on 21st Oct., 2014 Tanaka T.
	double msL;			// length of a slope cell nearby river channel ͓ (m)
	double msB;     	// width of a slope cell nearby river channel ͓ (m)
	double msDx;		// space of a slope cell nearby river channel ԍԊu (m)


	// ԗ
	double* mQc;	// current_time ł̗ (m3/s)
	double* mQn;	// current_time+time_step ł̗ (m3/s)
	double mQlc;	// current_time ł̑ (m2/s)
	double mQln;	// current_time+time_step ł̑ (m2/s)
	double* mAc;	// current_time ł̒ʐfʐ (m2)
	double* mAn;	// current_time+time_step ł̒ʐfʐ (m2)
	//Added on 21st Oct., 2014 Tanaka T.
	double* msQc;	// current_time ł͓̉ߖT̎Ζʂ̗ (m3/s)
	double* msQn;	// current_time+time_step ł͓̉ߖT̎Ζʂ̗ (m3/s)


	void setElevation(int rowStep, int colStep, int row, int col, float SWlat, float SWlon, float elevation, float topoScale);
	void setNULL();
	void setDownStreamGrid(int row, int col, class Cell** cell2);	
	void setUpStreamGrid();
	void countNumberOfUpStreamGrid();

	//Command to get location of the corresponding rainfall cell
	/*------------------------------------*/
	void PutROFCell(ROF** fROF, int ix, int iy);
	/*------------------------------------*/
//	void setROFCell(ROF** fROF, int row_ROF, int col_ROF);
	void setROFCell(ROF** fROF, int row_ROF, int col_ROF, int*& rofRC);

	//Edited by K. Miyawaki 2015
	void setBasinID();
	int basinID;				/* p[^𕪕z邽߂̕ϐB(-1)C (0)̑ (2)F (3)ؒÐ */
	void initialize(double ini_lateral);
	void Set_parameter(double wMan_channel, double wMan_slope, double wKa, double wDa, double wDm, double wBeta, double wsL, double wsB, 
						int wthre_basin, int x_Div, int t_Div, double theta, int t_step_num, int Ndays);

	void Set_parameterRiverMouth(); //Added on July 10 2020 by Tachikawa

//	void initialize(double ini_lateral);
//	void Set_parameter(double wMan_channel, double wMan_slope, double wKa, double wDa, double wDm, double wBeta, double wsL, double wsB, 
//						int thre_basin, int x_Div, int t_Div, double theta, int t_step_num, int Ndays);

	void getLateralRunoff(int n_day, int n_hour);

	void CalculateRiver(int day, int hour, int nt);
	void CalculateBasin(int day, int hour, int nt);

	//Added on 21st Oct., 2014 Tanaka T.
	double CalculateRunoff(int day, int hour, int nt, double upInflow, double wQl);

	void writeQ(int year, int month, int day_num, int t_step_num, FILE *fout);
    void writeQBi(int year, int month, int day_num, int t_step_num, FILE *fout);
	float GetHourlyFlow(int day, int hour, int t_step_num);
	float GetDailyFlow(int day, int t_step_num);
	float GetHourlyFlowMax(int day, int t_step_num);
	void deleteQandA(int Ndays);

	//added and editied by Tachikawa 20200704
	float Get10minSnapShotFlow(int iday, int ihour, int dt, int Ntime10);
	float Get10minMeanFlow(int iday, int ihour, int dt, int Ntime10);

	//added and editied by Miyawaki K. 2015
	/*-----------------------------------------------*/
	float*** I_memory;			/* ,,vZ񐔂Ƃ̃Obhւ̗ʂLz */
	float GetHourlyInflow(int day, int hour, int t_step_num);

};



//added and editied by Miyawaki K. 2015
/*-----------------------------------------------*/
// added on May 20, 2013
// damCell NX̐錾 Cell NXpB
class damCell {
public:
	int damSimulationKind; // 0: use observed dam outflow, 1: use dam model
	int damCol;
	int damRow;
	int damID;
	char damName[20];
	char damFile[100];
	class Cell* damGrid;

	double storage;  // storage of dam (m3)
	double flood; // flood discharge (m3/s)
	double s0; // initial storage
	double s1; // water use storage
	double s2; //effective storage

	std::ifstream damFin;	// t@Cǂݍޏꍇ̃_nt@C

	float*** S_memory;   /* ,,vZ񐔂ƂstorageLz */

	void setDamGrid(char* wDamName, int wDamID, int wDamCol, int wDamRow, int Col, int Row, class Cell** cell, int wDamSimulationKind);
	void setDamInitialState(int Ndays, int t_step_num);
	void setDamParameter(double wFlood, double wPL, double wNL, double wSL);
	void readDamOutflow(int iday, int t_step_num);
	void readHourlyDamOutflow(int iday, int ihour, int t_step_num);//2016/1/25 Tanaka T.
	void calculateDamOutflow(int day, int hour, int t_step_num);
	float GetHourlyStorage(int day, int hour, int t_step_num);
	void deleteS(int Ndays);
};


// added on November 29, 2014
// resCell NX̐錾
// `rf
class resCell {

public:
	int resCol;
	int resRow;
	int resID;
	int rK;
	char resName[20];
	class Cell* resGrid;
	double a, b;

	double preInflow;
	double resOutflow;
	
	void setResGrid(char* wResName, int wResID, int wResCol, int wResRow, int Col, int Row, class Cell** cell);
	void setResInitialState();
	void setResParameter(int wrK);
	void calculateResOutflow(int day, int hour, int nt);
};
